/**
 * Autor 			: Alexandre Correia - alexandrecorreia@celepar.pr.gov.br
 * Data 			: 00/00/0000
 * Caso de Teste	: EL - 948 : Adicionar Compromisso Com Hora Final Anterior Hora Inicial
 * 
 * Descrio do Processo de Teste Cadastro no TestLink - http://testlink.expressolivre.org/ 
 * 
 * AES DO PASSO
 * P01. Usurio informa um ttulo para o compromisso;
 * P02. Usurio informa uma data e hora iniciais para o compromisso;
 * P03. Usurio informa a mesma data porm com hora final menor que a hora inicial do compromisso;
 * P04. Usurio pressiona opo para salvar o compromisso;
 * P05. Sistema exibe uma mensagem de erro informando o Usurio que a hora final no pode ser inferior a hora inicial e no salva o compromisso; 
 */

package br.gov.serpro.cte.agenda.casoteste;

import java.util.GregorianCalendar;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import br.gov.serpro.cte.agenda.Objetos.AdicionarCompromissoEL948.*;
import br.gov.serpro.cte.connection.DAOSelenium;
import br.gov.serpro.cte.connection.LoginExpresso;

import com.thoughtworks.selenium.SeleneseTestCase;

public class Test_EL_948_AdicionarCompromissoComHoraFinalAnteriorHoraInicial extends SeleneseTestCase
{
	@Before
	public void setUp() throws Exception
	{
		String url			= "https://cte.serpro.gov.br";
		DAOSelenium conn	= new DAOSelenium( "localhost", 4444, "*pifirefox", url);
		selenium			= conn.newConnection();
	}
	@Test
	public void testa()
	{
		// Logando No Expresso
		selenium.open("/login.php");
		selenium.type("user", LoginExpresso.USER_EXPRESSO.getValue());
		selenium.type("passwd", LoginExpresso.PASSWORD_EXPRESSO.getValue());
		selenium.click("submitit");
		selenium.waitForPageToLoad("30000");
		selenium.click("//html/body/div[@id='toolbar']/table/tbody/tr/td[2]/table/tbody/tr/td[3]/a/img[@id='calendarid']");

		// Data
		GregorianCalendar gc = new GregorianCalendar();
		String	Dia = String.valueOf( gc.get( gc.DAY_OF_MONTH ) );
				Dia = ( Dia.length() > 1 ) ? Dia : "0"+Dia; 
		
		String	Mes = String.valueOf( gc.get( gc.MONTH ) + 1 );
		
		String	Ano = String.valueOf( gc.get( gc.YEAR ) );
		
		//Adicionando um Evento
		selenium.open("/index.php?date=" + Ano + Mes + Dia + "&menuaction=calendar.uicalendar.week");
		selenium.click("//img[@title='Nova Entrada']");
		selenium.waitForPageToLoad("30000");
		
		for( Campo cmp : Campo.values() )
		{
			String cmpName = cmp.name();
				 
			if( cmp.getValue().indexOf("addSelection:") > -1 )
			{	
				AddSelection( cmp.getValue(), getValor( cmp.name() ) );
			}
			
			if( cmp.getValue().indexOf("click:") > -1 )
			{
				Click( cmp.getValue() );
			}
			
			if( cmp.getValue().indexOf("select:") > -1 )
			{
				Select( cmp.getValue(), getValor( cmp.name() ) );
			}
			
			if( cmp.getValue().indexOf("type:") > -1 )
			{
				Type( cmp.getValue(), getValor( cmp.name() ) );
			}
		}
		
		selenium.waitForPageToLoad("15000");
		
		// Verifica a Mensagem de Erro
		selenium.isTextPresent("A hora de inicio no pode ser maior do que a hora de trmino.");
		
	}
	
	public String getValor(String cmpName)
	{
		String _return = "";
		
		for( Valor vlr : Valor.values() )
		{
			 String vlrName = vlr.name();
			 
			 if( vlrName.equals( cmpName ) )
			 {
				 _return = vlr.getValue();
			 }
		}
		
		return _return;
	}
	
	public void AddSelection( String locator, String optionLocator )
	{
		selenium.addSelection( locator.substring( 13 , locator.length() ), optionLocator );
	}
	
	public void Click( String locator )
	{
		selenium.click( locator.substring( 6 , locator.length() ) );
	}

	public void Select( String selectLocator, String optionLocator )
	{
		selenium.select( selectLocator.substring( 7 , selectLocator.length() ), optionLocator );
	}

	public void Type( String locator, String value )
	{
		selenium.type( locator.substring( 5 , locator.length() ), value );
	}
	
	@After
	public void tearDown() throws Exception
	{
		selenium.close();
	}
}